% Generated from Funcon/Caml-Light/CL-Library.csf

sigdec(cl_base,decls,[]).

onestep(cl_base,A,B,resolve) :-
     unobs(A),
     rewrites(cl_base,B).

onestep(cl_base,A,B,typeval) :-
     unobs(A),
     rewrites(cl_base,B).

sigdec(cl_base_types,maps(ids,types),[]).

onestep(cl_base_types,A,B,resolve) :-
     unobs(A),
     rewrites(cl_base_types,B).

onestep(cl_base_types,A,B,typeval) :-
     unobs(A),
     rewrites(cl_base_types,B).

sigdec(cl_library,decls,[]).

onestep(cl_library,A,B,resolve) :-
     unobs(A),
     rewrites(cl_library,B).

onestep(cl_library,A,B,typeval) :-
     unobs(A),
     rewrites(cl_library,B).

sigdec(cl_library_types,maps(ids,types),[]).

onestep(cl_library_types,A,B,resolve) :-
     unobs(A),
     rewrites(cl_library_types,B).

onestep(cl_library_types,A,B,typeval) :-
     unobs(A),
     rewrites(cl_library_types,B).

onestep(cl_base,A,B,run) :-
     unobs(A),
     rewrites(map_empty,B).

onestep(cl_base,A,cl_base_types,inhabit) :-
     unobs(A).

rewrite(cl_base_types,ZZF) :-
     rewrites(map_empty,F),
     rewrites(q(builtin),B),
     rewrites(q(exn),A),
     rewrites(id(A),C),
     rewrites(nameid(B,C),G),
     rewrites(q(exn),D),
     rewrites(q(builtin),E),
     rewrites(nomtype(D,E),H),
     rewrites(map_update(F,G,H),L),
     rewrites(q(type),J),
     rewrites(q(unit),I),
     rewrites(id(I),K),
     rewrites(nameid(J,K),M),
     rewrites(unit,N),
     rewrites(map_update(L,M,N),R),
     rewrites(q(type),P),
     rewrites(q(string),O),
     rewrites(id(O),Q),
     rewrites(nameid(P,Q),S),
     rewrites(strings,T),
     rewrites(map_update(R,S,T),ZE),
     rewrites(q(type),V),
     rewrites(q(list),U),
     rewrites(id(U),W),
     rewrites(nameid(V,W),ZF),
     rewrites(q(a),X),
     rewrites(typevar(X),Y),
     rewrites(list_empty,Z),
     rewrites(list_prefix(Y,Z),ZC),
     rewrites(q(a),ZA),
     rewrites(typevar(ZA),ZB),
     rewrites(lists(ZB),ZD),
     rewrites(type_abs(ZC,ZD),ZG),
     rewrites(map_update(ZE,ZF,ZG),ZK),
     rewrites(q(type),ZI),
     rewrites(q(int),ZH),
     rewrites(id(ZH),ZJ),
     rewrites(nameid(ZI,ZJ),ZL),
     rewrites(ints,ZM),
     rewrites(map_update(ZK,ZL,ZM),ZQ),
     rewrites(q(type),ZO),
     rewrites(q(float),ZN),
     rewrites(id(ZN),ZP),
     rewrites(nameid(ZO,ZP),ZR),
     rewrites(floats,ZS),
     rewrites(map_update(ZQ,ZR,ZS),ZW),
     rewrites(q(type),ZU),
     rewrites(q(char),ZT),
     rewrites(id(ZT),ZV),
     rewrites(nameid(ZU,ZV),ZX),
     rewrites(characters,ZY),
     rewrites(map_update(ZW,ZX,ZY),ZZC),
     rewrites(q(type),ZZA),
     rewrites(q(bool),ZZ),
     rewrites(id(ZZ),ZZB),
     rewrites(nameid(ZZA,ZZB),ZZD),
     rewrites(booleans,ZZE),
     rewrites(map_update(ZZC,ZZD,ZZE),ZZF).

onestep(cl_library,A,ZZZZZZZZZZZO,run) :-
     unobs(A),
     rewrites(map_empty,ZC),
     rewrites(q(vect_assign),B),
     rewrites(id(B),ZD),
     rewrites(three,ZA),
     rewrites(one,C),
     rewrites(given,D),
     rewrites(project(C,D),H),
     rewrites(zero,E),
     rewrites(given,F),
     rewrites(project(E,F),G),
     rewrites(vector_length(G),I),
     rewrites(int_less(H,I),W),
     rewrites(zero,J),
     rewrites(given,K),
     rewrites(project(J,K),N),
     rewrites(one,L),
     rewrites(given,M),
     rewrites(project(L,M),O),
     rewrites(vector_select(N,O),R),
     rewrites(two,P),
     rewrites(given,Q),
     rewrites(project(P,Q),S),
     rewrites(assign(R,S),X),
     rewrites(q('"vect_assign"'),T),
     rewrites(str(T),U),
     rewrites(cl_invalid_argument(U),V),
     rewrites(throw(V),Y),
     rewrites(if_true(W,X,Y),Z),
     rewrites(abs(Z),ZB),
     rewrites(curry_N(ZA,ZB),ZE),
     rewrites(map_update(ZC,ZD,ZE),ZZC),
     rewrites(q(vect_item),ZF),
     rewrites(id(ZF),ZZD),
     rewrites(one,ZG),
     rewrites(given,ZH),
     rewrites(project(ZG,ZH),ZL),
     rewrites(zero,ZI),
     rewrites(given,ZJ),
     rewrites(project(ZI,ZJ),ZK),
     rewrites(vector_length(ZK),ZM),
     rewrites(int_less(ZL,ZM),ZX),
     rewrites(zero,ZN),
     rewrites(given,ZO),
     rewrites(project(ZN,ZO),ZR),
     rewrites(one,ZP),
     rewrites(given,ZQ),
     rewrites(project(ZP,ZQ),ZS),
     rewrites(vector_select(ZR,ZS),ZT),
     rewrites(assigned_value(ZT),ZY),
     rewrites(q('"vect_item"'),ZU),
     rewrites(str(ZU),ZV),
     rewrites(cl_invalid_argument(ZV),ZW),
     rewrites(throw(ZW),ZZ),
     rewrites(if_true(ZX,ZY,ZZ),ZZA),
     rewrites(abs(ZZA),ZZB),
     rewrites(curry(ZZB),ZZE),
     rewrites(map_update(ZZC,ZZD,ZZE),ZZH),
     rewrites(q(vect_length),ZZF),
     rewrites(id(ZZF),ZZI),
     rewrites(vector_length,ZZG),
     rewrites(abs1_1(ZZG),ZZJ),
     rewrites(map_update(ZZH,ZZI,ZZJ),ZZM),
     rewrites(q(print),ZZK),
     rewrites(id(ZZK),ZZN),
     rewrites(print,ZZL),
     rewrites(abs1_1(ZZL),ZZO),
     rewrites(map_update(ZZM,ZZN,ZZO),ZZR),
     rewrites(q(ref),ZZP),
     rewrites(id(ZZP),ZZS),
     rewrites(alloc,ZZQ),
     rewrites(abs1_1(ZZQ),ZZT),
     rewrites(map_update(ZZR,ZZS,ZZT),ZZZK),
     rewrites(q('prefix >='),ZZU),
     rewrites(id(ZZU),ZZZL),
     rewrites(given,ZZV),
     rewrites(cl_comparable(ZZV),ZZZF),
     rewrites(zero,ZZW),
     rewrites(given,ZZX),
     rewrites(project(ZZW,ZZX),ZZZA),
     rewrites(one,ZZY),
     rewrites(given,ZZZ),
     rewrites(project(ZZY,ZZZ),ZZZB),
     rewrites(greater_equal(ZZZA,ZZZB),ZZZG),
     rewrites(q('"equal: functional value"'),ZZZC),
     rewrites(str(ZZZC),ZZZD),
     rewrites(cl_invalid_argument(ZZZD),ZZZE),
     rewrites(throw(ZZZE),ZZZH),
     rewrites(if_true(ZZZF,ZZZG,ZZZH),ZZZI),
     rewrites(abs(ZZZI),ZZZJ),
     rewrites(curry(ZZZJ),ZZZM),
     rewrites(map_update(ZZZK,ZZZL,ZZZM),ZZZZD),
     rewrites(q('prefix <='),ZZZN),
     rewrites(id(ZZZN),ZZZZE),
     rewrites(given,ZZZO),
     rewrites(cl_comparable(ZZZO),ZZZY),
     rewrites(zero,ZZZP),
     rewrites(given,ZZZQ),
     rewrites(project(ZZZP,ZZZQ),ZZZT),
     rewrites(one,ZZZR),
     rewrites(given,ZZZS),
     rewrites(project(ZZZR,ZZZS),ZZZU),
     rewrites(less_equal(ZZZT,ZZZU),ZZZZ),
     rewrites(q('"equal: functional value"'),ZZZV),
     rewrites(str(ZZZV),ZZZW),
     rewrites(cl_invalid_argument(ZZZW),ZZZX),
     rewrites(throw(ZZZX),ZZZZA),
     rewrites(if_true(ZZZY,ZZZZ,ZZZZA),ZZZZB),
     rewrites(abs(ZZZZB),ZZZZC),
     rewrites(curry(ZZZZC),ZZZZF),
     rewrites(map_update(ZZZZD,ZZZZE,ZZZZF),ZZZZW),
     rewrites(q('prefix >'),ZZZZG),
     rewrites(id(ZZZZG),ZZZZX),
     rewrites(given,ZZZZH),
     rewrites(cl_comparable(ZZZZH),ZZZZR),
     rewrites(zero,ZZZZI),
     rewrites(given,ZZZZJ),
     rewrites(project(ZZZZI,ZZZZJ),ZZZZM),
     rewrites(one,ZZZZK),
     rewrites(given,ZZZZL),
     rewrites(project(ZZZZK,ZZZZL),ZZZZN),
     rewrites(greater(ZZZZM,ZZZZN),ZZZZS),
     rewrites(q('"equal: functional value"'),ZZZZO),
     rewrites(str(ZZZZO),ZZZZP),
     rewrites(cl_invalid_argument(ZZZZP),ZZZZQ),
     rewrites(throw(ZZZZQ),ZZZZT),
     rewrites(if_true(ZZZZR,ZZZZS,ZZZZT),ZZZZU),
     rewrites(abs(ZZZZU),ZZZZV),
     rewrites(curry(ZZZZV),ZZZZY),
     rewrites(map_update(ZZZZW,ZZZZX,ZZZZY),ZZZZZP),
     rewrites(q('prefix <'),ZZZZZ),
     rewrites(id(ZZZZZ),ZZZZZQ),
     rewrites(given,ZZZZZA),
     rewrites(cl_comparable(ZZZZZA),ZZZZZK),
     rewrites(zero,ZZZZZB),
     rewrites(given,ZZZZZC),
     rewrites(project(ZZZZZB,ZZZZZC),ZZZZZF),
     rewrites(one,ZZZZZD),
     rewrites(given,ZZZZZE),
     rewrites(project(ZZZZZD,ZZZZZE),ZZZZZG),
     rewrites(less(ZZZZZF,ZZZZZG),ZZZZZL),
     rewrites(q('"equal: functional value"'),ZZZZZH),
     rewrites(str(ZZZZZH),ZZZZZI),
     rewrites(cl_invalid_argument(ZZZZZI),ZZZZZJ),
     rewrites(throw(ZZZZZJ),ZZZZZM),
     rewrites(if_true(ZZZZZK,ZZZZZL,ZZZZZM),ZZZZZN),
     rewrites(abs(ZZZZZN),ZZZZZO),
     rewrites(curry(ZZZZZO),ZZZZZR),
     rewrites(map_update(ZZZZZP,ZZZZZQ,ZZZZZR),ZZZZZZI),
     rewrites(q(max),ZZZZZS),
     rewrites(id(ZZZZZS),ZZZZZZJ),
     rewrites(given,ZZZZZT),
     rewrites(cl_comparable(ZZZZZT),ZZZZZZD),
     rewrites(zero,ZZZZZU),
     rewrites(given,ZZZZZV),
     rewrites(project(ZZZZZU,ZZZZZV),ZZZZZY),
     rewrites(one,ZZZZZW),
     rewrites(given,ZZZZZX),
     rewrites(project(ZZZZZW,ZZZZZX),ZZZZZZ),
     rewrites(max(ZZZZZY,ZZZZZZ),ZZZZZZE),
     rewrites(q('"equal: functional value"'),ZZZZZZA),
     rewrites(str(ZZZZZZA),ZZZZZZB),
     rewrites(cl_invalid_argument(ZZZZZZB),ZZZZZZC),
     rewrites(throw(ZZZZZZC),ZZZZZZF),
     rewrites(if_true(ZZZZZZD,ZZZZZZE,ZZZZZZF),ZZZZZZG),
     rewrites(abs(ZZZZZZG),ZZZZZZH),
     rewrites(curry(ZZZZZZH),ZZZZZZK),
     rewrites(map_update(ZZZZZZI,ZZZZZZJ,ZZZZZZK),ZZZZZZZB),
     rewrites(q(min),ZZZZZZL),
     rewrites(id(ZZZZZZL),ZZZZZZZC),
     rewrites(given,ZZZZZZM),
     rewrites(cl_comparable(ZZZZZZM),ZZZZZZW),
     rewrites(zero,ZZZZZZN),
     rewrites(given,ZZZZZZO),
     rewrites(project(ZZZZZZN,ZZZZZZO),ZZZZZZR),
     rewrites(one,ZZZZZZP),
     rewrites(given,ZZZZZZQ),
     rewrites(project(ZZZZZZP,ZZZZZZQ),ZZZZZZS),
     rewrites(min(ZZZZZZR,ZZZZZZS),ZZZZZZX),
     rewrites(q('"equal: functional value"'),ZZZZZZT),
     rewrites(str(ZZZZZZT),ZZZZZZU),
     rewrites(cl_invalid_argument(ZZZZZZU),ZZZZZZV),
     rewrites(throw(ZZZZZZV),ZZZZZZY),
     rewrites(if_true(ZZZZZZW,ZZZZZZX,ZZZZZZY),ZZZZZZZ),
     rewrites(abs(ZZZZZZZ),ZZZZZZZA),
     rewrites(curry(ZZZZZZZA),ZZZZZZZD),
     rewrites(map_update(ZZZZZZZB,ZZZZZZZC,ZZZZZZZD),ZZZZZZZU),
     rewrites(q('prefix ='),ZZZZZZZE),
     rewrites(id(ZZZZZZZE),ZZZZZZZV),
     rewrites(given,ZZZZZZZF),
     rewrites(cl_comparable(ZZZZZZZF),ZZZZZZZP),
     rewrites(zero,ZZZZZZZG),
     rewrites(given,ZZZZZZZH),
     rewrites(project(ZZZZZZZG,ZZZZZZZH),ZZZZZZZK),
     rewrites(one,ZZZZZZZI),
     rewrites(given,ZZZZZZZJ),
     rewrites(project(ZZZZZZZI,ZZZZZZZJ),ZZZZZZZL),
     rewrites(cl_struct_equal(ZZZZZZZK,ZZZZZZZL),ZZZZZZZQ),
     rewrites(q('"equal: functional value"'),ZZZZZZZM),
     rewrites(str(ZZZZZZZM),ZZZZZZZN),
     rewrites(cl_invalid_argument(ZZZZZZZN),ZZZZZZZO),
     rewrites(throw(ZZZZZZZO),ZZZZZZZR),
     rewrites(if_true(ZZZZZZZP,ZZZZZZZQ,ZZZZZZZR),ZZZZZZZS),
     rewrites(abs(ZZZZZZZS),ZZZZZZZT),
     rewrites(curry(ZZZZZZZT),ZZZZZZZW),
     rewrites(map_update(ZZZZZZZU,ZZZZZZZV,ZZZZZZZW),ZZZZZZZZA),
     rewrites(q('prefix :='),ZZZZZZZX),
     rewrites(id(ZZZZZZZX),ZZZZZZZZB),
     rewrites(assign,ZZZZZZZY),
     rewrites(abs2_1(ZZZZZZZY),ZZZZZZZZ),
     rewrites(curry(ZZZZZZZZ),ZZZZZZZZC),
     rewrites(map_update(ZZZZZZZZA,ZZZZZZZZB,ZZZZZZZZC),ZZZZZZZZF),
     rewrites(q('prefix !'),ZZZZZZZZD),
     rewrites(id(ZZZZZZZZD),ZZZZZZZZG),
     rewrites(assigned_value,ZZZZZZZZE),
     rewrites(abs1_1(ZZZZZZZZE),ZZZZZZZZH),
     rewrites(map_update(ZZZZZZZZF,ZZZZZZZZG,ZZZZZZZZH),ZZZZZZZZL),
     rewrites(q('prefix ^'),ZZZZZZZZI),
     rewrites(id(ZZZZZZZZI),ZZZZZZZZM),
     rewrites(string_append,ZZZZZZZZJ),
     rewrites(abs2_1(ZZZZZZZZJ),ZZZZZZZZK),
     rewrites(curry(ZZZZZZZZK),ZZZZZZZZN),
     rewrites(map_update(ZZZZZZZZL,ZZZZZZZZM,ZZZZZZZZN),ZZZZZZZZQ),
     rewrites(q(string_of_int),ZZZZZZZZO),
     rewrites(id(ZZZZZZZZO),ZZZZZZZZR),
     rewrites(int_to_string,ZZZZZZZZP),
     rewrites(abs1_1(ZZZZZZZZP),ZZZZZZZZS),
     rewrites(map_update(ZZZZZZZZQ,ZZZZZZZZR,ZZZZZZZZS),ZZZZZZZZW),
     rewrites(q('prefix mod'),ZZZZZZZZT),
     rewrites(id(ZZZZZZZZT),ZZZZZZZZX),
     rewrites(int_modulo,ZZZZZZZZU),
     rewrites(abs2_1(ZZZZZZZZU),ZZZZZZZZV),
     rewrites(curry(ZZZZZZZZV),ZZZZZZZZY),
     rewrites(map_update(ZZZZZZZZW,ZZZZZZZZX,ZZZZZZZZY),ZZZZZZZZZC),
     rewrites(q('prefix /.'),ZZZZZZZZZ),
     rewrites(id(ZZZZZZZZZ),ZZZZZZZZZD),
     rewrites(float_divide,ZZZZZZZZZA),
     rewrites(abs2_1(ZZZZZZZZZA),ZZZZZZZZZB),
     rewrites(curry(ZZZZZZZZZB),ZZZZZZZZZE),
     rewrites(map_update(ZZZZZZZZZC,ZZZZZZZZZD,ZZZZZZZZZE),ZZZZZZZZZI),
     rewrites(q('prefix *.'),ZZZZZZZZZF),
     rewrites(id(ZZZZZZZZZF),ZZZZZZZZZJ),
     rewrites(float_times,ZZZZZZZZZG),
     rewrites(abs2_1(ZZZZZZZZZG),ZZZZZZZZZH),
     rewrites(curry(ZZZZZZZZZH),ZZZZZZZZZK),
     rewrites(map_update(ZZZZZZZZZI,ZZZZZZZZZJ,ZZZZZZZZZK),ZZZZZZZZZO),
     rewrites(q('prefix -.'),ZZZZZZZZZL),
     rewrites(id(ZZZZZZZZZL),ZZZZZZZZZP),
     rewrites(float_minus,ZZZZZZZZZM),
     rewrites(abs2_1(ZZZZZZZZZM),ZZZZZZZZZN),
     rewrites(curry(ZZZZZZZZZN),ZZZZZZZZZQ),
     rewrites(map_update(ZZZZZZZZZO,ZZZZZZZZZP,ZZZZZZZZZQ),ZZZZZZZZZU),
     rewrites(q('prefix +.'),ZZZZZZZZZR),
     rewrites(id(ZZZZZZZZZR),ZZZZZZZZZV),
     rewrites(float_plus,ZZZZZZZZZS),
     rewrites(abs2_1(ZZZZZZZZZS),ZZZZZZZZZT),
     rewrites(curry(ZZZZZZZZZT),ZZZZZZZZZW),
     rewrites(map_update(ZZZZZZZZZU,ZZZZZZZZZV,ZZZZZZZZZW),ZZZZZZZZZZO),
     rewrites(q('prefix /'),ZZZZZZZZZX),
     rewrites(id(ZZZZZZZZZX),ZZZZZZZZZZP),
     rewrites(one,ZZZZZZZZZY),
     rewrites(given,ZZZZZZZZZZ),
     rewrites(project(ZZZZZZZZZY,ZZZZZZZZZZ),ZZZZZZZZZZA),
     rewrites(q(0),ZZZZZZZZZZB),
     rewrites(equal(ZZZZZZZZZZA,ZZZZZZZZZZB),ZZZZZZZZZZJ),
     rewrites(cl_division_by_zero,ZZZZZZZZZZC),
     rewrites(throw(ZZZZZZZZZZC),ZZZZZZZZZZK),
     rewrites(zero,ZZZZZZZZZZD),
     rewrites(given,ZZZZZZZZZZE),
     rewrites(project(ZZZZZZZZZZD,ZZZZZZZZZZE),ZZZZZZZZZZH),
     rewrites(one,ZZZZZZZZZZF),
     rewrites(given,ZZZZZZZZZZG),
     rewrites(project(ZZZZZZZZZZF,ZZZZZZZZZZG),ZZZZZZZZZZI),
     rewrites(int_divide(ZZZZZZZZZZH,ZZZZZZZZZZI),ZZZZZZZZZZL),
     rewrites(if_true(ZZZZZZZZZZJ,ZZZZZZZZZZK,ZZZZZZZZZZL),ZZZZZZZZZZM),
     rewrites(abs(ZZZZZZZZZZM),ZZZZZZZZZZN),
     rewrites(curry(ZZZZZZZZZZN),ZZZZZZZZZZQ),
     rewrites(map_update(ZZZZZZZZZZO,ZZZZZZZZZZP,ZZZZZZZZZZQ),ZZZZZZZZZZU),
     rewrites(q('prefix *'),ZZZZZZZZZZR),
     rewrites(id(ZZZZZZZZZZR),ZZZZZZZZZZV),
     rewrites(int_times,ZZZZZZZZZZS),
     rewrites(abs2_1(ZZZZZZZZZZS),ZZZZZZZZZZT),
     rewrites(curry(ZZZZZZZZZZT),ZZZZZZZZZZW),
     rewrites(map_update(ZZZZZZZZZZU,ZZZZZZZZZZV,ZZZZZZZZZZW),ZZZZZZZZZZZA),
     rewrites(q('prefix -'),ZZZZZZZZZZX),
     rewrites(id(ZZZZZZZZZZX),ZZZZZZZZZZZB),
     rewrites(int_minus,ZZZZZZZZZZY),
     rewrites(abs2_1(ZZZZZZZZZZY),ZZZZZZZZZZZ),
     rewrites(curry(ZZZZZZZZZZZ),ZZZZZZZZZZZC),
     rewrites(map_update(ZZZZZZZZZZZA,ZZZZZZZZZZZB,ZZZZZZZZZZZC),ZZZZZZZZZZZG),
     rewrites(q('prefix +'),ZZZZZZZZZZZD),
     rewrites(id(ZZZZZZZZZZZD),ZZZZZZZZZZZH),
     rewrites(int_plus,ZZZZZZZZZZZE),
     rewrites(abs2_1(ZZZZZZZZZZZE),ZZZZZZZZZZZF),
     rewrites(curry(ZZZZZZZZZZZF),ZZZZZZZZZZZI),
     rewrites(map_update(ZZZZZZZZZZZG,ZZZZZZZZZZZH,ZZZZZZZZZZZI),ZZZZZZZZZZZL),
     rewrites(q(minus_int),ZZZZZZZZZZZJ),
     rewrites(id(ZZZZZZZZZZZJ),ZZZZZZZZZZZM),
     rewrites(int_negate,ZZZZZZZZZZZK),
     rewrites(abs1_1(ZZZZZZZZZZZK),ZZZZZZZZZZZN),
     rewrites(map_update(ZZZZZZZZZZZL,ZZZZZZZZZZZM,ZZZZZZZZZZZN),ZZZZZZZZZZZO).

onestep(cl_library,A,cl_library_types,inhabit) :-
     unobs(A).

rewrite(cl_library_types,ZZZZZZZZZZZZZZZZZZZZZV) :-
     rewrites(map_empty,H),
     rewrites(q(type),B),
     rewrites(q(exn),A),
     rewrites(id(A),C),
     rewrites(nameid(B,C),I),
     rewrites(q(builtin),E),
     rewrites(q(exn),D),
     rewrites(id(D),F),
     rewrites(nameid(E,F),G),
     rewrites(bound_type(G),J),
     rewrites(map_update(H,I,J),ZK),
     rewrites(q(vect_assign),K),
     rewrites(id(K),ZL),
     rewrites(q(prompt1),L),
     rewrites(typevar(L),S),
     rewrites(q(prompt2),M),
     rewrites(typevar(M),Q),
     rewrites(q(a),N),
     rewrites(typevar(N),O),
     rewrites(list_empty,P),
     rewrites(list_prefix(O,P),R),
     rewrites(list_prefix(Q,R),T),
     rewrites(list_prefix(S,T),ZI),
     rewrites(q(prompt1),U),
     rewrites(typevar(U),ZF),
     rewrites(q(a),V),
     rewrites(typevar(V),W),
     rewrites(vectors(W),ZG),
     rewrites(q(prompt2),X),
     rewrites(typevar(X),ZC),
     rewrites(ints,ZD),
     rewrites(none,Z),
     rewrites(q(a),Y),
     rewrites(typevar(Y),ZA),
     rewrites(unit,ZB),
     rewrites(abs(Z,ZA,ZB),ZE),
     rewrites(abs(ZC,ZD,ZE),ZH),
     rewrites(abs(ZF,ZG,ZH),ZJ),
     rewrites(forall(ZI,ZJ),ZM),
     rewrites(map_update(ZK,ZL,ZM),ZZK),
     rewrites(q(vect_item),ZN),
     rewrites(id(ZN),ZZL),
     rewrites(q(prompt1),ZO),
     rewrites(typevar(ZO),ZV),
     rewrites(q(prompt2),ZP),
     rewrites(typevar(ZP),ZT),
     rewrites(q(a),ZQ),
     rewrites(typevar(ZQ),ZR),
     rewrites(list_empty,ZS),
     rewrites(list_prefix(ZR,ZS),ZU),
     rewrites(list_prefix(ZT,ZU),ZW),
     rewrites(list_prefix(ZV,ZW),ZZI),
     rewrites(q(prompt1),ZX),
     rewrites(typevar(ZX),ZZF),
     rewrites(q(a),ZY),
     rewrites(typevar(ZY),ZZ),
     rewrites(vectors(ZZ),ZZG),
     rewrites(q(prompt2),ZZA),
     rewrites(typevar(ZZA),ZZC),
     rewrites(ints,ZZD),
     rewrites(q(a),ZZB),
     rewrites(typevar(ZZB),ZZE),
     rewrites(abs(ZZC,ZZD,ZZE),ZZH),
     rewrites(abs(ZZF,ZZG,ZZH),ZZJ),
     rewrites(forall(ZZI,ZZJ),ZZM),
     rewrites(map_update(ZZK,ZZL,ZZM),ZZZC),
     rewrites(q(vect_length),ZZN),
     rewrites(id(ZZN),ZZZD),
     rewrites(q(prompt),ZZO),
     rewrites(typevar(ZZO),ZZS),
     rewrites(q(a),ZZP),
     rewrites(typevar(ZZP),ZZQ),
     rewrites(list_empty,ZZR),
     rewrites(list_prefix(ZZQ,ZZR),ZZT),
     rewrites(list_prefix(ZZS,ZZT),ZZZA),
     rewrites(q(prompt),ZZU),
     rewrites(typevar(ZZU),ZZX),
     rewrites(q(a),ZZV),
     rewrites(typevar(ZZV),ZZW),
     rewrites(vectors(ZZW),ZZY),
     rewrites(ints,ZZZ),
     rewrites(abs(ZZX,ZZY,ZZZ),ZZZB),
     rewrites(forall(ZZZA,ZZZB),ZZZE),
     rewrites(map_update(ZZZC,ZZZD,ZZZE),ZZZT),
     rewrites(q(print),ZZZF),
     rewrites(id(ZZZF),ZZZU),
     rewrites(q(prompt),ZZZG),
     rewrites(typevar(ZZZG),ZZZK),
     rewrites(q(a),ZZZH),
     rewrites(typevar(ZZZH),ZZZI),
     rewrites(list_empty,ZZZJ),
     rewrites(list_prefix(ZZZI,ZZZJ),ZZZL),
     rewrites(list_prefix(ZZZK,ZZZL),ZZZR),
     rewrites(q(prompt),ZZZM),
     rewrites(typevar(ZZZM),ZZZO),
     rewrites(q(a),ZZZN),
     rewrites(typevar(ZZZN),ZZZP),
     rewrites(unit,ZZZQ),
     rewrites(abs(ZZZO,ZZZP,ZZZQ),ZZZS),
     rewrites(forall(ZZZR,ZZZS),ZZZV),
     rewrites(map_update(ZZZT,ZZZU,ZZZV),ZZZZM),
     rewrites(q(ref),ZZZW),
     rewrites(id(ZZZW),ZZZZN),
     rewrites(q(prompt),ZZZX),
     rewrites(typevar(ZZZX),ZZZZB),
     rewrites(q(a),ZZZY),
     rewrites(typevar(ZZZY),ZZZZ),
     rewrites(list_empty,ZZZZA),
     rewrites(list_prefix(ZZZZ,ZZZZA),ZZZZC),
     rewrites(list_prefix(ZZZZB,ZZZZC),ZZZZK),
     rewrites(q(prompt),ZZZZD),
     rewrites(typevar(ZZZZD),ZZZZH),
     rewrites(q(a),ZZZZE),
     rewrites(typevar(ZZZZE),ZZZZI),
     rewrites(q(a),ZZZZF),
     rewrites(typevar(ZZZZF),ZZZZG),
     rewrites(variables(ZZZZG),ZZZZJ),
     rewrites(abs(ZZZZH,ZZZZI,ZZZZJ),ZZZZL),
     rewrites(forall(ZZZZK,ZZZZL),ZZZZO),
     rewrites(map_update(ZZZZM,ZZZZN,ZZZZO),ZZZZZL),
     rewrites(q('prefix >='),ZZZZP),
     rewrites(id(ZZZZP),ZZZZZM),
     rewrites(q(prompt1),ZZZZQ),
     rewrites(typevar(ZZZZQ),ZZZZX),
     rewrites(q(prompt2),ZZZZR),
     rewrites(typevar(ZZZZR),ZZZZV),
     rewrites(q(a),ZZZZS),
     rewrites(typevar(ZZZZS),ZZZZT),
     rewrites(list_empty,ZZZZU),
     rewrites(list_prefix(ZZZZT,ZZZZU),ZZZZW),
     rewrites(list_prefix(ZZZZV,ZZZZW),ZZZZY),
     rewrites(list_prefix(ZZZZX,ZZZZY),ZZZZZJ),
     rewrites(q(prompt1),ZZZZZ),
     rewrites(typevar(ZZZZZ),ZZZZZG),
     rewrites(q(a),ZZZZZA),
     rewrites(typevar(ZZZZZA),ZZZZZH),
     rewrites(q(prompt2),ZZZZZB),
     rewrites(typevar(ZZZZZB),ZZZZZD),
     rewrites(q(a),ZZZZZC),
     rewrites(typevar(ZZZZZC),ZZZZZE),
     rewrites(booleans,ZZZZZF),
     rewrites(abs(ZZZZZD,ZZZZZE,ZZZZZF),ZZZZZI),
     rewrites(abs(ZZZZZG,ZZZZZH,ZZZZZI),ZZZZZK),
     rewrites(forall(ZZZZZJ,ZZZZZK),ZZZZZN),
     rewrites(map_update(ZZZZZL,ZZZZZM,ZZZZZN),ZZZZZZK),
     rewrites(q('prefix <='),ZZZZZO),
     rewrites(id(ZZZZZO),ZZZZZZL),
     rewrites(q(prompt1),ZZZZZP),
     rewrites(typevar(ZZZZZP),ZZZZZW),
     rewrites(q(prompt2),ZZZZZQ),
     rewrites(typevar(ZZZZZQ),ZZZZZU),
     rewrites(q(a),ZZZZZR),
     rewrites(typevar(ZZZZZR),ZZZZZS),
     rewrites(list_empty,ZZZZZT),
     rewrites(list_prefix(ZZZZZS,ZZZZZT),ZZZZZV),
     rewrites(list_prefix(ZZZZZU,ZZZZZV),ZZZZZX),
     rewrites(list_prefix(ZZZZZW,ZZZZZX),ZZZZZZI),
     rewrites(q(prompt1),ZZZZZY),
     rewrites(typevar(ZZZZZY),ZZZZZZF),
     rewrites(q(a),ZZZZZZ),
     rewrites(typevar(ZZZZZZ),ZZZZZZG),
     rewrites(q(prompt2),ZZZZZZA),
     rewrites(typevar(ZZZZZZA),ZZZZZZC),
     rewrites(q(a),ZZZZZZB),
     rewrites(typevar(ZZZZZZB),ZZZZZZD),
     rewrites(booleans,ZZZZZZE),
     rewrites(abs(ZZZZZZC,ZZZZZZD,ZZZZZZE),ZZZZZZH),
     rewrites(abs(ZZZZZZF,ZZZZZZG,ZZZZZZH),ZZZZZZJ),
     rewrites(forall(ZZZZZZI,ZZZZZZJ),ZZZZZZM),
     rewrites(map_update(ZZZZZZK,ZZZZZZL,ZZZZZZM),ZZZZZZZJ),
     rewrites(q('prefix >'),ZZZZZZN),
     rewrites(id(ZZZZZZN),ZZZZZZZK),
     rewrites(q(prompt1),ZZZZZZO),
     rewrites(typevar(ZZZZZZO),ZZZZZZV),
     rewrites(q(prompt2),ZZZZZZP),
     rewrites(typevar(ZZZZZZP),ZZZZZZT),
     rewrites(q(a),ZZZZZZQ),
     rewrites(typevar(ZZZZZZQ),ZZZZZZR),
     rewrites(list_empty,ZZZZZZS),
     rewrites(list_prefix(ZZZZZZR,ZZZZZZS),ZZZZZZU),
     rewrites(list_prefix(ZZZZZZT,ZZZZZZU),ZZZZZZW),
     rewrites(list_prefix(ZZZZZZV,ZZZZZZW),ZZZZZZZH),
     rewrites(q(prompt1),ZZZZZZX),
     rewrites(typevar(ZZZZZZX),ZZZZZZZE),
     rewrites(q(a),ZZZZZZY),
     rewrites(typevar(ZZZZZZY),ZZZZZZZF),
     rewrites(q(prompt2),ZZZZZZZ),
     rewrites(typevar(ZZZZZZZ),ZZZZZZZB),
     rewrites(q(a),ZZZZZZZA),
     rewrites(typevar(ZZZZZZZA),ZZZZZZZC),
     rewrites(booleans,ZZZZZZZD),
     rewrites(abs(ZZZZZZZB,ZZZZZZZC,ZZZZZZZD),ZZZZZZZG),
     rewrites(abs(ZZZZZZZE,ZZZZZZZF,ZZZZZZZG),ZZZZZZZI),
     rewrites(forall(ZZZZZZZH,ZZZZZZZI),ZZZZZZZL),
     rewrites(map_update(ZZZZZZZJ,ZZZZZZZK,ZZZZZZZL),ZZZZZZZZI),
     rewrites(q('prefix <'),ZZZZZZZM),
     rewrites(id(ZZZZZZZM),ZZZZZZZZJ),
     rewrites(q(prompt1),ZZZZZZZN),
     rewrites(typevar(ZZZZZZZN),ZZZZZZZU),
     rewrites(q(prompt2),ZZZZZZZO),
     rewrites(typevar(ZZZZZZZO),ZZZZZZZS),
     rewrites(q(a),ZZZZZZZP),
     rewrites(typevar(ZZZZZZZP),ZZZZZZZQ),
     rewrites(list_empty,ZZZZZZZR),
     rewrites(list_prefix(ZZZZZZZQ,ZZZZZZZR),ZZZZZZZT),
     rewrites(list_prefix(ZZZZZZZS,ZZZZZZZT),ZZZZZZZV),
     rewrites(list_prefix(ZZZZZZZU,ZZZZZZZV),ZZZZZZZZG),
     rewrites(q(prompt1),ZZZZZZZW),
     rewrites(typevar(ZZZZZZZW),ZZZZZZZZD),
     rewrites(q(a),ZZZZZZZX),
     rewrites(typevar(ZZZZZZZX),ZZZZZZZZE),
     rewrites(q(prompt2),ZZZZZZZY),
     rewrites(typevar(ZZZZZZZY),ZZZZZZZZA),
     rewrites(q(a),ZZZZZZZZ),
     rewrites(typevar(ZZZZZZZZ),ZZZZZZZZB),
     rewrites(booleans,ZZZZZZZZC),
     rewrites(abs(ZZZZZZZZA,ZZZZZZZZB,ZZZZZZZZC),ZZZZZZZZF),
     rewrites(abs(ZZZZZZZZD,ZZZZZZZZE,ZZZZZZZZF),ZZZZZZZZH),
     rewrites(forall(ZZZZZZZZG,ZZZZZZZZH),ZZZZZZZZK),
     rewrites(map_update(ZZZZZZZZI,ZZZZZZZZJ,ZZZZZZZZK),ZZZZZZZZZI),
     rewrites(q(min),ZZZZZZZZL),
     rewrites(id(ZZZZZZZZL),ZZZZZZZZZJ),
     rewrites(q(prompt1),ZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZM),ZZZZZZZZT),
     rewrites(q(prompt2),ZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZN),ZZZZZZZZR),
     rewrites(q(a),ZZZZZZZZO),
     rewrites(typevar(ZZZZZZZZO),ZZZZZZZZP),
     rewrites(list_empty,ZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZP,ZZZZZZZZQ),ZZZZZZZZS),
     rewrites(list_prefix(ZZZZZZZZR,ZZZZZZZZS),ZZZZZZZZU),
     rewrites(list_prefix(ZZZZZZZZT,ZZZZZZZZU),ZZZZZZZZZG),
     rewrites(q(prompt1),ZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZV),ZZZZZZZZZD),
     rewrites(q(a),ZZZZZZZZW),
     rewrites(typevar(ZZZZZZZZW),ZZZZZZZZZE),
     rewrites(q(prompt2),ZZZZZZZZX),
     rewrites(typevar(ZZZZZZZZX),ZZZZZZZZZA),
     rewrites(q(a),ZZZZZZZZY),
     rewrites(typevar(ZZZZZZZZY),ZZZZZZZZZB),
     rewrites(q(a),ZZZZZZZZZ),
     rewrites(typevar(ZZZZZZZZZ),ZZZZZZZZZC),
     rewrites(abs(ZZZZZZZZZA,ZZZZZZZZZB,ZZZZZZZZZC),ZZZZZZZZZF),
     rewrites(abs(ZZZZZZZZZD,ZZZZZZZZZE,ZZZZZZZZZF),ZZZZZZZZZH),
     rewrites(forall(ZZZZZZZZZG,ZZZZZZZZZH),ZZZZZZZZZK),
     rewrites(map_update(ZZZZZZZZZI,ZZZZZZZZZJ,ZZZZZZZZZK),ZZZZZZZZZZI),
     rewrites(q(max),ZZZZZZZZZL),
     rewrites(id(ZZZZZZZZZL),ZZZZZZZZZZJ),
     rewrites(q(prompt1),ZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZM),ZZZZZZZZZT),
     rewrites(q(prompt2),ZZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZZN),ZZZZZZZZZR),
     rewrites(q(a),ZZZZZZZZZO),
     rewrites(typevar(ZZZZZZZZZO),ZZZZZZZZZP),
     rewrites(list_empty,ZZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZZP,ZZZZZZZZZQ),ZZZZZZZZZS),
     rewrites(list_prefix(ZZZZZZZZZR,ZZZZZZZZZS),ZZZZZZZZZU),
     rewrites(list_prefix(ZZZZZZZZZT,ZZZZZZZZZU),ZZZZZZZZZZG),
     rewrites(q(prompt1),ZZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZZV),ZZZZZZZZZZD),
     rewrites(q(a),ZZZZZZZZZW),
     rewrites(typevar(ZZZZZZZZZW),ZZZZZZZZZZE),
     rewrites(q(prompt2),ZZZZZZZZZX),
     rewrites(typevar(ZZZZZZZZZX),ZZZZZZZZZZA),
     rewrites(q(a),ZZZZZZZZZY),
     rewrites(typevar(ZZZZZZZZZY),ZZZZZZZZZZB),
     rewrites(q(a),ZZZZZZZZZZ),
     rewrites(typevar(ZZZZZZZZZZ),ZZZZZZZZZZC),
     rewrites(abs(ZZZZZZZZZZA,ZZZZZZZZZZB,ZZZZZZZZZZC),ZZZZZZZZZZF),
     rewrites(abs(ZZZZZZZZZZD,ZZZZZZZZZZE,ZZZZZZZZZZF),ZZZZZZZZZZH),
     rewrites(forall(ZZZZZZZZZZG,ZZZZZZZZZZH),ZZZZZZZZZZK),
     rewrites(map_update(ZZZZZZZZZZI,ZZZZZZZZZZJ,ZZZZZZZZZZK),ZZZZZZZZZZZH),
     rewrites(q('prefix ='),ZZZZZZZZZZL),
     rewrites(id(ZZZZZZZZZZL),ZZZZZZZZZZZI),
     rewrites(q(prompt1),ZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZM),ZZZZZZZZZZT),
     rewrites(q(prompt2),ZZZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZZZN),ZZZZZZZZZZR),
     rewrites(q(a),ZZZZZZZZZZO),
     rewrites(typevar(ZZZZZZZZZZO),ZZZZZZZZZZP),
     rewrites(list_empty,ZZZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZZZP,ZZZZZZZZZZQ),ZZZZZZZZZZS),
     rewrites(list_prefix(ZZZZZZZZZZR,ZZZZZZZZZZS),ZZZZZZZZZZU),
     rewrites(list_prefix(ZZZZZZZZZZT,ZZZZZZZZZZU),ZZZZZZZZZZZF),
     rewrites(q(prompt1),ZZZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZZZV),ZZZZZZZZZZZC),
     rewrites(q(a),ZZZZZZZZZZW),
     rewrites(typevar(ZZZZZZZZZZW),ZZZZZZZZZZZD),
     rewrites(q(prompt2),ZZZZZZZZZZX),
     rewrites(typevar(ZZZZZZZZZZX),ZZZZZZZZZZZ),
     rewrites(q(a),ZZZZZZZZZZY),
     rewrites(typevar(ZZZZZZZZZZY),ZZZZZZZZZZZA),
     rewrites(booleans,ZZZZZZZZZZZB),
     rewrites(abs(ZZZZZZZZZZZ,ZZZZZZZZZZZA,ZZZZZZZZZZZB),ZZZZZZZZZZZE),
     rewrites(abs(ZZZZZZZZZZZC,ZZZZZZZZZZZD,ZZZZZZZZZZZE),ZZZZZZZZZZZG),
     rewrites(forall(ZZZZZZZZZZZF,ZZZZZZZZZZZG),ZZZZZZZZZZZJ),
     rewrites(map_update(ZZZZZZZZZZZH,ZZZZZZZZZZZI,ZZZZZZZZZZZJ),ZZZZZZZZZZZZH),
     rewrites(q('prefix :='),ZZZZZZZZZZZK),
     rewrites(id(ZZZZZZZZZZZK),ZZZZZZZZZZZZI),
     rewrites(q(prompt1),ZZZZZZZZZZZL),
     rewrites(typevar(ZZZZZZZZZZZL),ZZZZZZZZZZZS),
     rewrites(q(prompt2),ZZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZZM),ZZZZZZZZZZZQ),
     rewrites(q(a),ZZZZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZZZZN),ZZZZZZZZZZZO),
     rewrites(list_empty,ZZZZZZZZZZZP),
     rewrites(list_prefix(ZZZZZZZZZZZO,ZZZZZZZZZZZP),ZZZZZZZZZZZR),
     rewrites(list_prefix(ZZZZZZZZZZZQ,ZZZZZZZZZZZR),ZZZZZZZZZZZT),
     rewrites(list_prefix(ZZZZZZZZZZZS,ZZZZZZZZZZZT),ZZZZZZZZZZZZF),
     rewrites(q(prompt1),ZZZZZZZZZZZU),
     rewrites(typevar(ZZZZZZZZZZZU),ZZZZZZZZZZZZC),
     rewrites(q(a),ZZZZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZZZZV),ZZZZZZZZZZZW),
     rewrites(variables(ZZZZZZZZZZZW),ZZZZZZZZZZZZD),
     rewrites(q(prompt2),ZZZZZZZZZZZX),
     rewrites(typevar(ZZZZZZZZZZZX),ZZZZZZZZZZZZ),
     rewrites(q(a),ZZZZZZZZZZZY),
     rewrites(typevar(ZZZZZZZZZZZY),ZZZZZZZZZZZZA),
     rewrites(unit,ZZZZZZZZZZZZB),
     rewrites(abs(ZZZZZZZZZZZZ,ZZZZZZZZZZZZA,ZZZZZZZZZZZZB),ZZZZZZZZZZZZE),
     rewrites(abs(ZZZZZZZZZZZZC,ZZZZZZZZZZZZD,ZZZZZZZZZZZZE),ZZZZZZZZZZZZG),
     rewrites(forall(ZZZZZZZZZZZZF,ZZZZZZZZZZZZG),ZZZZZZZZZZZZJ),
     rewrites(map_update(ZZZZZZZZZZZZH,ZZZZZZZZZZZZI,ZZZZZZZZZZZZJ),ZZZZZZZZZZZZZA),
     rewrites(q('prefix !'),ZZZZZZZZZZZZK),
     rewrites(id(ZZZZZZZZZZZZK),ZZZZZZZZZZZZZB),
     rewrites(q(prompt),ZZZZZZZZZZZZL),
     rewrites(typevar(ZZZZZZZZZZZZL),ZZZZZZZZZZZZP),
     rewrites(q(a),ZZZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZZZM),ZZZZZZZZZZZZN),
     rewrites(list_empty,ZZZZZZZZZZZZO),
     rewrites(list_prefix(ZZZZZZZZZZZZN,ZZZZZZZZZZZZO),ZZZZZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZZZZZP,ZZZZZZZZZZZZQ),ZZZZZZZZZZZZY),
     rewrites(q(prompt),ZZZZZZZZZZZZR),
     rewrites(typevar(ZZZZZZZZZZZZR),ZZZZZZZZZZZZV),
     rewrites(q(a),ZZZZZZZZZZZZS),
     rewrites(typevar(ZZZZZZZZZZZZS),ZZZZZZZZZZZZT),
     rewrites(variables(ZZZZZZZZZZZZT),ZZZZZZZZZZZZW),
     rewrites(q(a),ZZZZZZZZZZZZU),
     rewrites(typevar(ZZZZZZZZZZZZU),ZZZZZZZZZZZZX),
     rewrites(abs(ZZZZZZZZZZZZV,ZZZZZZZZZZZZW,ZZZZZZZZZZZZX),ZZZZZZZZZZZZZ),
     rewrites(forall(ZZZZZZZZZZZZY,ZZZZZZZZZZZZZ),ZZZZZZZZZZZZZC),
     rewrites(map_update(ZZZZZZZZZZZZZA,ZZZZZZZZZZZZZB,ZZZZZZZZZZZZZC),ZZZZZZZZZZZZZU),
     rewrites(q('prefix ^'),ZZZZZZZZZZZZZD),
     rewrites(id(ZZZZZZZZZZZZZD),ZZZZZZZZZZZZZV),
     rewrites(q(prompt1),ZZZZZZZZZZZZZE),
     rewrites(typevar(ZZZZZZZZZZZZZE),ZZZZZZZZZZZZZI),
     rewrites(q(prompt2),ZZZZZZZZZZZZZF),
     rewrites(typevar(ZZZZZZZZZZZZZF),ZZZZZZZZZZZZZG),
     rewrites(list_empty,ZZZZZZZZZZZZZH),
     rewrites(list_prefix(ZZZZZZZZZZZZZG,ZZZZZZZZZZZZZH),ZZZZZZZZZZZZZJ),
     rewrites(list_prefix(ZZZZZZZZZZZZZI,ZZZZZZZZZZZZZJ),ZZZZZZZZZZZZZS),
     rewrites(q(prompt1),ZZZZZZZZZZZZZK),
     rewrites(typevar(ZZZZZZZZZZZZZK),ZZZZZZZZZZZZZP),
     rewrites(strings,ZZZZZZZZZZZZZQ),
     rewrites(q(prompt2),ZZZZZZZZZZZZZL),
     rewrites(typevar(ZZZZZZZZZZZZZL),ZZZZZZZZZZZZZM),
     rewrites(strings,ZZZZZZZZZZZZZN),
     rewrites(strings,ZZZZZZZZZZZZZO),
     rewrites(abs(ZZZZZZZZZZZZZM,ZZZZZZZZZZZZZN,ZZZZZZZZZZZZZO),ZZZZZZZZZZZZZR),
     rewrites(abs(ZZZZZZZZZZZZZP,ZZZZZZZZZZZZZQ,ZZZZZZZZZZZZZR),ZZZZZZZZZZZZZT),
     rewrites(forall(ZZZZZZZZZZZZZS,ZZZZZZZZZZZZZT),ZZZZZZZZZZZZZW),
     rewrites(map_update(ZZZZZZZZZZZZZU,ZZZZZZZZZZZZZV,ZZZZZZZZZZZZZW),ZZZZZZZZZZZZZZH),
     rewrites(q(string_of_int),ZZZZZZZZZZZZZX),
     rewrites(id(ZZZZZZZZZZZZZX),ZZZZZZZZZZZZZZI),
     rewrites(q(prompt),ZZZZZZZZZZZZZY),
     rewrites(typevar(ZZZZZZZZZZZZZY),ZZZZZZZZZZZZZZ),
     rewrites(list_empty,ZZZZZZZZZZZZZZA),
     rewrites(list_prefix(ZZZZZZZZZZZZZZ,ZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZF),
     rewrites(q(prompt),ZZZZZZZZZZZZZZB),
     rewrites(typevar(ZZZZZZZZZZZZZZB),ZZZZZZZZZZZZZZC),
     rewrites(ints,ZZZZZZZZZZZZZZD),
     rewrites(strings,ZZZZZZZZZZZZZZE),
     rewrites(abs(ZZZZZZZZZZZZZZC,ZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZE),ZZZZZZZZZZZZZZG),
     rewrites(forall(ZZZZZZZZZZZZZZF,ZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZJ),
     rewrites(map_update(ZZZZZZZZZZZZZZH,ZZZZZZZZZZZZZZI,ZZZZZZZZZZZZZZJ),ZZZZZZZZZZZZZZZB),
     rewrites(q('prefix mod'),ZZZZZZZZZZZZZZK),
     rewrites(id(ZZZZZZZZZZZZZZK),ZZZZZZZZZZZZZZZC),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZL),
     rewrites(typevar(ZZZZZZZZZZZZZZL),ZZZZZZZZZZZZZZP),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZN),
     rewrites(list_empty,ZZZZZZZZZZZZZZO),
     rewrites(list_prefix(ZZZZZZZZZZZZZZN,ZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZZZZZZZP,ZZZZZZZZZZZZZZQ),ZZZZZZZZZZZZZZZ),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZR),
     rewrites(typevar(ZZZZZZZZZZZZZZR),ZZZZZZZZZZZZZZW),
     rewrites(ints,ZZZZZZZZZZZZZZX),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZS),
     rewrites(typevar(ZZZZZZZZZZZZZZS),ZZZZZZZZZZZZZZT),
     rewrites(ints,ZZZZZZZZZZZZZZU),
     rewrites(ints,ZZZZZZZZZZZZZZV),
     rewrites(abs(ZZZZZZZZZZZZZZT,ZZZZZZZZZZZZZZU,ZZZZZZZZZZZZZZV),ZZZZZZZZZZZZZZY),
     rewrites(abs(ZZZZZZZZZZZZZZW,ZZZZZZZZZZZZZZX,ZZZZZZZZZZZZZZY),ZZZZZZZZZZZZZZZA),
     rewrites(forall(ZZZZZZZZZZZZZZZ,ZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZD),
     rewrites(map_update(ZZZZZZZZZZZZZZZB,ZZZZZZZZZZZZZZZC,ZZZZZZZZZZZZZZZD),ZZZZZZZZZZZZZZZV),
     rewrites(q('prefix /.'),ZZZZZZZZZZZZZZZE),
     rewrites(id(ZZZZZZZZZZZZZZZE),ZZZZZZZZZZZZZZZW),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZF),
     rewrites(typevar(ZZZZZZZZZZZZZZZF),ZZZZZZZZZZZZZZZJ),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZG),
     rewrites(typevar(ZZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZZH),
     rewrites(list_empty,ZZZZZZZZZZZZZZZI),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZH,ZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZK),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZJ,ZZZZZZZZZZZZZZZK),ZZZZZZZZZZZZZZZT),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZL),
     rewrites(typevar(ZZZZZZZZZZZZZZZL),ZZZZZZZZZZZZZZZQ),
     rewrites(floats,ZZZZZZZZZZZZZZZR),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZZN),
     rewrites(floats,ZZZZZZZZZZZZZZZO),
     rewrites(floats,ZZZZZZZZZZZZZZZP),
     rewrites(abs(ZZZZZZZZZZZZZZZN,ZZZZZZZZZZZZZZZO,ZZZZZZZZZZZZZZZP),ZZZZZZZZZZZZZZZS),
     rewrites(abs(ZZZZZZZZZZZZZZZQ,ZZZZZZZZZZZZZZZR,ZZZZZZZZZZZZZZZS),ZZZZZZZZZZZZZZZU),
     rewrites(forall(ZZZZZZZZZZZZZZZT,ZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZX),
     rewrites(map_update(ZZZZZZZZZZZZZZZV,ZZZZZZZZZZZZZZZW,ZZZZZZZZZZZZZZZX),ZZZZZZZZZZZZZZZZP),
     rewrites(q('prefix *.'),ZZZZZZZZZZZZZZZY),
     rewrites(id(ZZZZZZZZZZZZZZZY),ZZZZZZZZZZZZZZZZQ),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZ),
     rewrites(typevar(ZZZZZZZZZZZZZZZZ),ZZZZZZZZZZZZZZZZD),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZA),
     rewrites(typevar(ZZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZZB),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZC),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZB,ZZZZZZZZZZZZZZZZC),ZZZZZZZZZZZZZZZZE),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZZZE),ZZZZZZZZZZZZZZZZN),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZF),
     rewrites(typevar(ZZZZZZZZZZZZZZZZF),ZZZZZZZZZZZZZZZZK),
     rewrites(floats,ZZZZZZZZZZZZZZZZL),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZG),
     rewrites(typevar(ZZZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZZZH),
     rewrites(floats,ZZZZZZZZZZZZZZZZI),
     rewrites(floats,ZZZZZZZZZZZZZZZZJ),
     rewrites(abs(ZZZZZZZZZZZZZZZZH,ZZZZZZZZZZZZZZZZI,ZZZZZZZZZZZZZZZZJ),ZZZZZZZZZZZZZZZZM),
     rewrites(abs(ZZZZZZZZZZZZZZZZK,ZZZZZZZZZZZZZZZZL,ZZZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZZZO),
     rewrites(forall(ZZZZZZZZZZZZZZZZN,ZZZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZZZR),
     rewrites(map_update(ZZZZZZZZZZZZZZZZP,ZZZZZZZZZZZZZZZZQ,ZZZZZZZZZZZZZZZZR),ZZZZZZZZZZZZZZZZZJ),
     rewrites(q('prefix -.'),ZZZZZZZZZZZZZZZZS),
     rewrites(id(ZZZZZZZZZZZZZZZZS),ZZZZZZZZZZZZZZZZZK),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZT),
     rewrites(typevar(ZZZZZZZZZZZZZZZZT),ZZZZZZZZZZZZZZZZX),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZU),
     rewrites(typevar(ZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZV),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZW),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZV,ZZZZZZZZZZZZZZZZW),ZZZZZZZZZZZZZZZZY),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZX,ZZZZZZZZZZZZZZZZY),ZZZZZZZZZZZZZZZZZH),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZ),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZ),ZZZZZZZZZZZZZZZZZE),
     rewrites(floats,ZZZZZZZZZZZZZZZZZF),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZA),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZZZB),
     rewrites(floats,ZZZZZZZZZZZZZZZZZC),
     rewrites(floats,ZZZZZZZZZZZZZZZZZD),
     rewrites(abs(ZZZZZZZZZZZZZZZZZB,ZZZZZZZZZZZZZZZZZC,ZZZZZZZZZZZZZZZZZD),ZZZZZZZZZZZZZZZZZG),
     rewrites(abs(ZZZZZZZZZZZZZZZZZE,ZZZZZZZZZZZZZZZZZF,ZZZZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZZZZI),
     rewrites(forall(ZZZZZZZZZZZZZZZZZH,ZZZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZZZL),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZJ,ZZZZZZZZZZZZZZZZZK,ZZZZZZZZZZZZZZZZZL),ZZZZZZZZZZZZZZZZZZD),
     rewrites(q('prefix +.'),ZZZZZZZZZZZZZZZZZM),
     rewrites(id(ZZZZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZZZZZE),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZN),ZZZZZZZZZZZZZZZZZR),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZO),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZZZZP),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZQ),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZP,ZZZZZZZZZZZZZZZZZQ),ZZZZZZZZZZZZZZZZZS),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZR,ZZZZZZZZZZZZZZZZZS),ZZZZZZZZZZZZZZZZZZB),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZT),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZT),ZZZZZZZZZZZZZZZZZY),
     rewrites(floats,ZZZZZZZZZZZZZZZZZZ),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZU),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZZV),
     rewrites(floats,ZZZZZZZZZZZZZZZZZW),
     rewrites(floats,ZZZZZZZZZZZZZZZZZX),
     rewrites(abs(ZZZZZZZZZZZZZZZZZV,ZZZZZZZZZZZZZZZZZW,ZZZZZZZZZZZZZZZZZX),ZZZZZZZZZZZZZZZZZZA),
     rewrites(abs(ZZZZZZZZZZZZZZZZZY,ZZZZZZZZZZZZZZZZZZ,ZZZZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZZZZC),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZB,ZZZZZZZZZZZZZZZZZZC),ZZZZZZZZZZZZZZZZZZF),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZZZZZE,ZZZZZZZZZZZZZZZZZZF),ZZZZZZZZZZZZZZZZZZX),
     rewrites(q('prefix /'),ZZZZZZZZZZZZZZZZZZG),
     rewrites(id(ZZZZZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZZZZZY),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZH),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZH),ZZZZZZZZZZZZZZZZZZL),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZI),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZZZZJ),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZZK),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZJ,ZZZZZZZZZZZZZZZZZZK),ZZZZZZZZZZZZZZZZZZM),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZL,ZZZZZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZZZZZV),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZN),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZN),ZZZZZZZZZZZZZZZZZZS),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZT),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZO),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZZZZZP),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZQ),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZR),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZP,ZZZZZZZZZZZZZZZZZZQ,ZZZZZZZZZZZZZZZZZZR),ZZZZZZZZZZZZZZZZZZU),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZS,ZZZZZZZZZZZZZZZZZZT,ZZZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZZZW),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZV,ZZZZZZZZZZZZZZZZZZW),ZZZZZZZZZZZZZZZZZZZ),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZX,ZZZZZZZZZZZZZZZZZZY,ZZZZZZZZZZZZZZZZZZZ),ZZZZZZZZZZZZZZZZZZZR),
     rewrites(q('prefix *'),ZZZZZZZZZZZZZZZZZZZA),
     rewrites(id(ZZZZZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZZZZZS),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZB),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZB),ZZZZZZZZZZZZZZZZZZZF),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZC),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZC),ZZZZZZZZZZZZZZZZZZZD),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZZZE),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZZZZZZE),ZZZZZZZZZZZZZZZZZZZG),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZF,ZZZZZZZZZZZZZZZZZZZG),ZZZZZZZZZZZZZZZZZZZP),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZH),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZH),ZZZZZZZZZZZZZZZZZZZM),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZN),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZI),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZZZZZJ),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZK),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZL),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZJ,ZZZZZZZZZZZZZZZZZZZK,ZZZZZZZZZZZZZZZZZZZL),ZZZZZZZZZZZZZZZZZZZO),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZM,ZZZZZZZZZZZZZZZZZZZN,ZZZZZZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZZZZZZQ),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZZP,ZZZZZZZZZZZZZZZZZZZQ),ZZZZZZZZZZZZZZZZZZZT),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZZR,ZZZZZZZZZZZZZZZZZZZS,ZZZZZZZZZZZZZZZZZZZT),ZZZZZZZZZZZZZZZZZZZZL),
     rewrites(q('prefix -'),ZZZZZZZZZZZZZZZZZZZU),
     rewrites(id(ZZZZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZZZZZM),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZV),ZZZZZZZZZZZZZZZZZZZZ),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZW),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZW),ZZZZZZZZZZZZZZZZZZZX),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZZZY),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZX,ZZZZZZZZZZZZZZZZZZZY),ZZZZZZZZZZZZZZZZZZZZA),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZZ,ZZZZZZZZZZZZZZZZZZZZA),ZZZZZZZZZZZZZZZZZZZZJ),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZZB),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZB),ZZZZZZZZZZZZZZZZZZZZG),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZH),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZZC),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZC),ZZZZZZZZZZZZZZZZZZZZD),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZE),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZF),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZZZZZZZE,ZZZZZZZZZZZZZZZZZZZZF),ZZZZZZZZZZZZZZZZZZZZI),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZZG,ZZZZZZZZZZZZZZZZZZZZH,ZZZZZZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZZZZZZK),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZZZJ,ZZZZZZZZZZZZZZZZZZZZK),ZZZZZZZZZZZZZZZZZZZZN),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZZZL,ZZZZZZZZZZZZZZZZZZZZM,ZZZZZZZZZZZZZZZZZZZZN),ZZZZZZZZZZZZZZZZZZZZZF),
     rewrites(q('prefix +'),ZZZZZZZZZZZZZZZZZZZZO),
     rewrites(id(ZZZZZZZZZZZZZZZZZZZZO),ZZZZZZZZZZZZZZZZZZZZZG),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZZP),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZP),ZZZZZZZZZZZZZZZZZZZZT),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZZQ),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZQ),ZZZZZZZZZZZZZZZZZZZZR),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZZZZS),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZZR,ZZZZZZZZZZZZZZZZZZZZS),ZZZZZZZZZZZZZZZZZZZZU),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZZT,ZZZZZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZZZZZZD),
     rewrites(q(prompt1),ZZZZZZZZZZZZZZZZZZZZV),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZV),ZZZZZZZZZZZZZZZZZZZZZA),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZZB),
     rewrites(q(prompt2),ZZZZZZZZZZZZZZZZZZZZW),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZW),ZZZZZZZZZZZZZZZZZZZZX),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZY),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZZ),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZZX,ZZZZZZZZZZZZZZZZZZZZY,ZZZZZZZZZZZZZZZZZZZZZ),ZZZZZZZZZZZZZZZZZZZZZC),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZZZA,ZZZZZZZZZZZZZZZZZZZZZB,ZZZZZZZZZZZZZZZZZZZZZC),ZZZZZZZZZZZZZZZZZZZZZE),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZZZZD,ZZZZZZZZZZZZZZZZZZZZZE),ZZZZZZZZZZZZZZZZZZZZZH),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZZZZF,ZZZZZZZZZZZZZZZZZZZZZG,ZZZZZZZZZZZZZZZZZZZZZH),ZZZZZZZZZZZZZZZZZZZZZS),
     rewrites(q(minus_int),ZZZZZZZZZZZZZZZZZZZZZI),
     rewrites(id(ZZZZZZZZZZZZZZZZZZZZZI),ZZZZZZZZZZZZZZZZZZZZZT),
     rewrites(q(prompt),ZZZZZZZZZZZZZZZZZZZZZJ),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZZJ),ZZZZZZZZZZZZZZZZZZZZZK),
     rewrites(list_empty,ZZZZZZZZZZZZZZZZZZZZZL),
     rewrites(list_prefix(ZZZZZZZZZZZZZZZZZZZZZK,ZZZZZZZZZZZZZZZZZZZZZL),ZZZZZZZZZZZZZZZZZZZZZQ),
     rewrites(q(prompt),ZZZZZZZZZZZZZZZZZZZZZM),
     rewrites(typevar(ZZZZZZZZZZZZZZZZZZZZZM),ZZZZZZZZZZZZZZZZZZZZZN),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZZO),
     rewrites(ints,ZZZZZZZZZZZZZZZZZZZZZP),
     rewrites(abs(ZZZZZZZZZZZZZZZZZZZZZN,ZZZZZZZZZZZZZZZZZZZZZO,ZZZZZZZZZZZZZZZZZZZZZP),ZZZZZZZZZZZZZZZZZZZZZR),
     rewrites(forall(ZZZZZZZZZZZZZZZZZZZZZQ,ZZZZZZZZZZZZZZZZZZZZZR),ZZZZZZZZZZZZZZZZZZZZZU),
     rewrites(map_update(ZZZZZZZZZZZZZZZZZZZZZS,ZZZZZZZZZZZZZZZZZZZZZT,ZZZZZZZZZZZZZZZZZZZZZU),ZZZZZZZZZZZZZZZZZZZZZV).

