% Generated from Funcon/Funcons/list_prefix_match#3.csf

sigdec(list_prefix_match,decls,[lists(_),patts,patts]).

onestep(list_prefix_match(A,B,C),E,L,run) :-
     rewrites(A,F),
     rewrites(B,G),
     rewrites(C,D),
     runstep(D,E,H) ->
     rewrites(F,I),
     rewrites(G,J),
     rewrites(H,K),
     rewrites(list_prefix_match(I,J,K),L).

onestep(list_prefix_match(A,B,C),E,L,run) :-
     rewrites(A,F),
     rewrites(B,D),
     rewrites(C,H),
     runstep(D,E,G) ->
     rewrites(F,I),
     rewrites(G,J),
     rewrites(H,K),
     rewrites(list_prefix_match(I,J,K),L).

onestep(list_prefix_match(A,B,C),E,L,run) :-
     rewrites(A,D),
     rewrites(B,G),
     rewrites(C,H),
     runstep(D,E,F) ->
     rewrites(F,I),
     rewrites(G,J),
     rewrites(H,K),
     rewrites(list_prefix_match(I,J,K),L).

onestep(list_prefix_match(A,B,C),K,R,resolve) :-
     rewrites(A,D),
     rewrites(B,E),
     rewrites(C,F),
     pre_comp(K,I),
     onestep(D,I,L,resolve) ->
     mid_comp(I,J),
     pre_comp(J,G),
     onestep(E,G,M,resolve) ->
     mid_comp(G,H),
     onestep(F,H,N,resolve) ->
     post_comp(G,H,J),
     post_comp(I,J,K),
     rewrites(L,O),
     rewrites(M,P),
     rewrites(N,Q),
     rewrites(list_prefix_match(O,P,Q),R).

onestep(list_prefix_match(A,B,C),K,R,typeval) :-
     rewrites(A,D),
     rewrites(B,E),
     rewrites(C,F),
     pre_comp(K,I),
     typeval(D,I,L) ->
     mid_comp(I,J),
     pre_comp(J,G),
     typeval(E,G,M) ->
     mid_comp(G,H),
     typeval(F,H,N) ->
     post_comp(G,H,J),
     post_comp(I,J,K),
     rewrites(L,O),
     rewrites(M,P),
     rewrites(N,Q),
     rewrites(list_prefix_match(O,P,Q),R).

sigdec(list_prefix_match,decls,[computes(lists(_)),computes(patts),computes(patts)]).

rewrite(list_prefix_match(A,B,C),D) :-
     rewrites(A,list_empty),
     rewrites(B,_),
     rewrites(C,_),
     rewrites(fail,D).

rewrite(list_prefix_match(A,D,E),P) :-
     rewrites(A,list_prefix(B,C)),
     rewrites(B,F),
     rewrites(C,J),
     rewrites(D,G),
     rewrites(E,K),
     rewrites(F,H),
     rewrites(G,I),
     rewrites(match(H,I),N),
     rewrites(J,L),
     rewrites(K,M),
     rewrites(match(L,M),O),
     rewrites(map_union(N,O),P).

onestep(list_prefix_match(A,B,C),D,map_union(O,V),inhabit) :-
     rewrites(A,H),
     rewrites(B,L),
     rewrites(C,Q),
     rewrites(T,F),
     eq_label(D,[answer=E|ZA]),
     rewrites(E,F),
     pre_comp(ZA,Y),
     rewrites(T,G),
     J=[answer=G|Y],
     rewrites(H,I),
     inhabit(I,J,lists(U)) ->
     mid_comp(Y,Z),
     pre_comp(Z,W),
     rewrites(T,K),
     N=[answer=K|W],
     rewrites(L,M),
     inhabit(M,N,abs(T,U,O)) ->
     mid_comp(W,X),
     rewrites(T,P),
     S=[answer=P|X],
     rewrites(Q,R),
     inhabit(R,S,abs(T,lists(U),V)) ->
     post_comp(W,X,Z),
     post_comp(Y,Z,ZA).

sigdec(list_prefix_patt,patts,[patts,patts]).

onestep(list_prefix_patt(A,B),D,I,run) :-
     rewrites(A,E),
     rewrites(B,C),
     runstep(C,D,F) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(list_prefix_patt(G,H),I).

onestep(list_prefix_patt(A,B),D,I,run) :-
     rewrites(A,C),
     rewrites(B,F),
     runstep(C,D,E) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(list_prefix_patt(G,H),I).

onestep(list_prefix_patt(A,B),G,L,resolve) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     onestep(C,E,H,resolve) ->
     mid_comp(E,F),
     onestep(D,F,I,resolve) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(list_prefix_patt(J,K),L).

onestep(list_prefix_patt(A,B),G,L,typeval) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     typeval(C,E,H) ->
     mid_comp(E,F),
     typeval(D,F,I) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(list_prefix_patt(J,K),L).

sigdec(list_prefix_patt,computes(patts),[computes(patts),computes(patts)]).

rewrite(list_prefix_patt(A,B),M) :-
     rewrites(A,C),
     rewrites(B,E),
     rewrites(C,D),
     runcheck(D,val),
     checktag(D,val,G),
     rewrites(E,F),
     runcheck(F,val),
     checktag(F,val,H),
     rewrites(given,I),
     rewrites(G,J),
     rewrites(H,K),
     rewrites(list_prefix_match(I,J,K),L),
     rewrites(abs(L),M).

onestep(list_prefix_patt(A,B),M,abs(H,lists(I),map_union(E,J)),inhabit) :-
     rewrites(A,C),
     rewrites(B,F),
     pre_comp(M,K),
     rewrites(C,D),
     inhabit(D,K,abs(H,I,E)) ->
     mid_comp(K,L),
     rewrites(F,G),
     inhabit(G,L,abs(H,lists(I),J)) ->
     post_comp(K,L,M). 

