% Generated from Funcon/Funcons/vector_alloc#2.csf

sigdec(vector_alloc,computes(vectors),[ints,_]).

onestep(vector_alloc(A,B),D,I,run) :-
     rewrites(A,E),
     rewrites(B,C),
     runstep(C,D,F) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(vector_alloc(G,H),I).

onestep(vector_alloc(A,B),D,I,run) :-
     rewrites(A,C),
     rewrites(B,F),
     runstep(C,D,E) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(vector_alloc(G,H),I).

onestep(vector_alloc(A,B),G,L,resolve) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     onestep(C,E,H,resolve) ->
     mid_comp(E,F),
     onestep(D,F,I,resolve) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(vector_alloc(J,K),L).

onestep(vector_alloc(A,B),G,L,typeval) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     typeval(C,E,H) ->
     mid_comp(E,F),
     typeval(D,F,I) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(vector_alloc(J,K),L).

sigdec(vector_alloc,computes(vectors),[computes(ints),_]).

rewrite(vector_alloc(A,B),E) :-
     rewrites(A,q(0)),
     rewrites(B,C),
     rewrites(C,D),
     runcheck(D,val),
     checktag(D,val,_),
     rewrites(vector_empty,E).

rewrite(vector_alloc(A,B),O) :-
     rewrites(A,G),
     rewrites(B,C),
     rewrites(C,D),
     runcheck(D,val),
     checktag(D,val,J),
     rewrites(int_greater(G,q(0)),true),
     rewrites(J,E),
     rewrites(alloc(E),F),
     rewrites(vector1(F),M),
     rewrites(G,H),
     rewrites(q(1),I),
     rewrites(int_minus(H,I),K),
     rewrites(J,L),
     rewrites(vector_alloc(K,L),N),
     rewrites(vector_append(M,N),O).

onestep(vector_alloc(A,B),J,vectors(G),inhabit) :-
     rewrites(A,C),
     rewrites(B,E),
     pre_comp(J,H),
     rewrites(C,D),
     inhabit(D,H,ints) ->
     mid_comp(H,I),
     rewrites(E,F),
     inhabit(F,I,G) ->
     post_comp(H,I,J). 

