% Generated from Funcon/Values/nameids.csf

sigdec(nameid,nameids,[namespaces,ids]).

onestep(nameid(A,B),K,nameids(E,H),inhabit) :-
     rewrites(A,C),
     rewrites(B,F),
     pre_comp(K,I),
     rewrites(C,D),
     inhabit(D,I,E) ->
     mid_comp(I,J),
     rewrites(F,G),
     inhabit(G,J,H) ->
     post_comp(I,J,K). 

onestep(nameid(A,B),D,I,run) :-
     rewrites(A,E),
     rewrites(B,C),
     runstep(C,D,F) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(nameid(G,H),I).

onestep(nameid(A,B),D,I,run) :-
     rewrites(A,C),
     rewrites(B,F),
     runstep(C,D,E) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(nameid(G,H),I).

onestep(nameid(A,B),G,L,resolve) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     onestep(C,E,H,resolve) ->
     mid_comp(E,F),
     onestep(D,F,I,resolve) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(nameid(J,K),L).

onestep(nameid(A,B),G,L,typeval) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     typeval(C,E,H) ->
     mid_comp(E,F),
     typeval(D,F,I) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(nameid(J,K),L).

sigdec(nameid,computes(nameids),[computes(namespaces),computes(ids)]).

valcons(nameid).

sigdec(nameids,types,[]).

onestep(nameids,A,B,resolve) :-
     unobs(A),
     rewrites(nameids,B).

onestep(nameids,A,B,typeval) :-
     unobs(A),
     rewrites(nameids,B).

valsort(nameids).

subsort(nameids,ids).

