% Generated from Funcon/Values/strings.csf

sigdec(strings,types,[]).

onestep(strings,A,B,resolve) :-
     unobs(A),
     rewrites(strings,B).

onestep(strings,A,B,typeval) :-
     unobs(A),
     rewrites(strings,B).

valsort(strings).

onestep(strings,A,types,inhabit) :-
     unobs(A).

sigdec(string_append,strings,[strings,strings]).

onestep(string_append(A,B),I,strings,inhabit) :-
     rewrites(A,C),
     rewrites(B,E),
     pre_comp(I,G),
     rewrites(C,D),
     inhabit(D,G,strings) ->
     mid_comp(G,H),
     rewrites(E,F),
     inhabit(F,H,strings) ->
     post_comp(G,H,I). 

onestep(string_append(A,B),D,I,run) :-
     rewrites(A,E),
     rewrites(B,C),
     runstep(C,D,F) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(string_append(G,H),I).

onestep(string_append(A,B),D,I,run) :-
     rewrites(A,C),
     rewrites(B,F),
     runstep(C,D,E) ->
     rewrites(E,G),
     rewrites(F,H),
     rewrites(string_append(G,H),I).

onestep(string_append(A,B),G,L,resolve) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     onestep(C,E,H,resolve) ->
     mid_comp(E,F),
     onestep(D,F,I,resolve) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(string_append(J,K),L).

onestep(string_append(A,B),G,L,typeval) :-
     rewrites(A,C),
     rewrites(B,D),
     pre_comp(G,E),
     typeval(C,E,H) ->
     mid_comp(E,F),
     typeval(D,F,I) ->
     post_comp(E,F,G),
     rewrites(H,J),
     rewrites(I,K),
     rewrites(string_append(J,K),L).

sigdec(string_append,computes(strings),[computes(strings),computes(strings)]).

sigdec(int_to_string,strings,[ints]).

onestep(int_to_string(A),D,strings,inhabit) :-
     rewrites(A,B),
     rewrites(B,C),
     inhabit(C,D,ints).

onestep(int_to_string(A),C,F,run) :-
     rewrites(A,B),
     runstep(B,C,D) ->
     rewrites(D,E),
     rewrites(int_to_string(E),F).

onestep(int_to_string(A),C,F,resolve) :-
     rewrites(A,B),
     onestep(B,C,D,resolve) ->
     rewrites(D,E),
     rewrites(int_to_string(E),F).

onestep(int_to_string(A),C,F,typeval) :-
     rewrites(A,B),
     typeval(B,C,D) ->
     rewrites(D,E),
     rewrites(int_to_string(E),F).

sigdec(int_to_string,computes(strings),[computes(ints)]).

